//----------------------------------------------------------------------//
// HtmlImgQ																//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <System.StrUtils.hpp>
#include <Vcl.Clipbrd.hpp>
#include <Vcl.GraphUtil.hpp>
#include "usr_wic.h"
#include "usr_str.h"
#include "Unit1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
THtmlImgForm *HtmlImgForm;

//---------------------------------------------------------------------------
__fastcall THtmlImgForm::THtmlImgForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::FormCreate(TObject *Sender)
{
	IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));

	//NIvV̏
	int i = 1;
	while (!ParamStr(i).IsEmpty()) {
		UnicodeString prmbuf = ParamStr(i++).Trim().UpperCase();
		if (remove_top_text(prmbuf, "-")) {
			if		(remove_top_text(prmbuf, "D"))	DocPath = exclude_quot(prmbuf);
			else if (remove_top_text(prmbuf, "I"))	ImgPath = exclude_quot(prmbuf);
		}
	}

	AlignComboBox->Items->Text =
		"top\r\n"
		"middle\r\n"
		"bottom\r\n"
		"left\r\n"
		"right\r\n";
}
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::FormShow(TObject *Sender)
{
	UnicodeString sct  = "General";
	BorderEdit->Text		= IniFile->ReadString( sct, "Border", EmptyStr);
	BrRadioGroup->ItemIndex = IniFile->ReadInteger(sct, "BrMode", 2);

	SelectBtnClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	UnicodeString sct  = "General";
	IniFile->WriteString( sct, "Border",	BorderEdit->Text);
	IniFile->WriteInteger(sct, "BrMode",	BrRadioGroup->ItemIndex);
}

//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::FormDestroy(TObject *Sender)
{
	delete IniFile;
}
//---------------------------------------------------------------------------
//摜̑I
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::SelectBtnClick(TObject *Sender)
{
	OpenPictureDialog1->Title = "摜̑I";
	OpenPictureDialog1->Filter
		= "JPEG File (*.JPG)|*.JPG;*.JPE;*.JPEG|PNG File(*.PNG)|*.PNG|GIF File(*.GIF)|*.GIF";
	UnicodeString dnam = ImgPath;
	if (dnam.IsEmpty()) dnam = IniFile->ReadString("ImgDir", DocPath,	DocPath);
	OpenPictureDialog1->InitialDir = dnam;
	OpenPictureDialog1->FileName   = EmptyStr;
	OpenPictureDialog1->Options << ofAllowMultiSelect;
	if (OpenPictureDialog1->Execute()) {
		ImgListBox->Items->Assign(OpenPictureDialog1->Files);
		if (!DocPath.IsEmpty()) IniFile->WriteString("ImgDir", DocPath,	ExtractFileDir(OpenPictureDialog1->FileName));
	}
}

//---------------------------------------------------------------------------
//폜
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::DelBtnActionExecute(TObject *Sender)
{
	TListBox *lp = ImgListBox;
	int idx = lp->ItemIndex;
	if (idx!=-1) {
		lp->Items->Delete(idx);
		lp->ItemIndex = (idx<lp->Count)? idx : lp->Count-1;
	}
}
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::DelBtnActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);  if (ap==NULL) return;
	ap->Enabled = (ImgListBox->ItemIndex!=-1);
}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::UpBtnActionExecute(TObject *Sender)
{
	TListBox *lp = ImgListBox;
	int idx = lp->ItemIndex;
	if (idx>=1 && idx<lp->Count) {
		lp->Items->Move(idx, idx-1);
		lp->ItemIndex = idx-1;
	}
}
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::UpBtnActionUpdate(TObject *Sender)
{
	TAction  *ap = dynamic_cast<TAction *>(Sender);  if (ap==NULL) return;
	int idx = ImgListBox->ItemIndex;
	ap->Enabled = (idx>=1 && idx<ImgListBox->Count);
}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::DowBtnActionExecute(TObject *Sender)
{
	TListBox *lp = ImgListBox;
	int idx = lp->ItemIndex;
	if (idx>=0 && idx<lp->Count-1) {
		lp->Items->Move(idx, idx+1);
		lp->ItemIndex = idx+1;
	}
}
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::DowBtnActionUpdate(TObject *Sender)
{
	TAction  *ap = dynamic_cast<TAction *>(Sender);  if (ap==NULL) return;
	int idx = ImgListBox->ItemIndex;
	ap->Enabled = (idx>=0 && idx<ImgListBox->Count-1);
}

//---------------------------------------------------------------------------
//LZ
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::CancelBtnClick(TObject *Sender)
{
	Clipboard()->AsText = EmptyStr;
	Close();
}

//---------------------------------------------------------------------------
//m
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::OkActionExecute(TObject *Sender)
{
	std::unique_ptr<TStringList> o_lst(new TStringList());
	for (int i=0; i<ImgListBox->Count; i++) {
		UnicodeString fnam = ImgListBox->Items->Strings[i];
		UnicodeString lbuf = "<img src=\"" + ReplaceStr(abs_to_reldir(fnam, DocPath),"\\", "/") + "\" alt=\"\"";
		//TCY擾
		unsigned int wd, hi;
		if (WIC_get_img_size(fnam, &wd, &hi))
			lbuf.cat_sprintf(_T(" height=\"%u\" width=\"%u\""), hi, wd);
		else
			lbuf += " height=\"\" width=\"\"";
		//̑̑
		if (!AlignComboBox->Text.IsEmpty())	lbuf += " align=\""  + AlignComboBox->Text + "\"";
		if (!BorderEdit->Text.IsEmpty())	lbuf += " border=\"" + BorderEdit->Text.Trim() + "\""; 
		if (!HspaceEdit->Text.IsEmpty())	lbuf += " hspace=\"" + HspaceEdit->Text.Trim() + "\""; 
		if (!VspaceEdit->Text.IsEmpty())	lbuf += " vspace=\"" + VspaceEdit->Text.Trim() + "\""; 
		lbuf += ">";

		switch (BrRadioGroup->ItemIndex) {
		case 1: lbuf += "<br>";		break;
		case 2: lbuf += "<br />";	break;
		}
		o_lst->Add(lbuf);
	}

	UnicodeString RetText = o_lst->Text;
	if (BrRadioGroup->ItemIndex==3) RetText = ReplaceStr(RetText, "\r\n", EmptyStr);
	Clipboard()->AsText = RetText;
	Close();
}
//---------------------------------------------------------------------------
void __fastcall THtmlImgForm::OkActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);  if (ap==NULL) return;
	ap->Enabled = ImgListBox->Count>0;
}
//---------------------------------------------------------------------------

